--- old/usr/src/uts/common/fs/zfs/metaslab.c	Fri Aug 11 03:00:25 2017
+++ new/usr/src/uts/common/fs/zfs/metaslab.c	Fri Aug 11 03:00:25 2017
@@ -1662,7 +1662,7 @@
 	 * In effect, this means that we'll select the metaslab with the most
 	 * free bandwidth rather than simply the one with the most free space.
 	 */
-	if (metaslab_lba_weighting_enabled) {
+	if (!vd->vdev_nonrot && metaslab_lba_weighting_enabled) {
 		weight = 2 * weight - (msp->ms_id * weight) / vd->vdev_ms_count;
 		ASSERT(weight >= space && weight <= 2 * space);
 	}
